<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>7. Binary Data Services &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="The Python Standard Library" href="index.html" />
    <link rel="next" title="7.1. struct — Interpret bytes as packed binary data" href="struct.html" />
    <link rel="prev" title="6.8. rlcompleter — Completion function for GNU readline" href="rlcompleter.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="struct.html" title="7.1. struct — Interpret bytes as packed binary data"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="rlcompleter.html" title="6.8. rlcompleter — Completion function for GNU readline"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">The Python Standard Library</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="binary-data-services">
<span id="binaryservices"></span><h1>7. Binary Data Services<a class="headerlink" href="#binary-data-services" title="Permalink to this headline">¶</a></h1>
<p>The modules described in this chapter provide some basic services operations
for manipulation of binary data. Other operations on binary data, specifically
in relation to file formats and network protocols, are described in the
relevant sections.</p>
<p>Some libraries described under <a class="reference internal" href="text.html#textservices"><span>Text Processing Services</span></a> also work with either
ASCII-compatible binary formats (for example, <a class="reference internal" href="re.html#module-re" title="re: Regular expression operations."><code class="xref py py-mod docutils literal"><span class="pre">re</span></code></a>) or all binary data
(for example, <a class="reference internal" href="difflib.html#module-difflib" title="difflib: Helpers for computing differences between objects."><code class="xref py py-mod docutils literal"><span class="pre">difflib</span></code></a>).</p>
<p>In addition, see the documentation for Python&#8217;s built-in binary data types in
<a class="reference internal" href="stdtypes.html#binaryseq"><span>Binary Sequence Types &#8212; bytes, bytearray, memoryview</span></a>.</p>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="struct.html">7.1. <code class="docutils literal"><span class="pre">struct</span></code> &#8212; Interpret bytes as packed binary data</a><ul>
<li class="toctree-l2"><a class="reference internal" href="struct.html#functions-and-exceptions">7.1.1. Functions and Exceptions</a></li>
<li class="toctree-l2"><a class="reference internal" href="struct.html#format-strings">7.1.2. Format Strings</a><ul>
<li class="toctree-l3"><a class="reference internal" href="struct.html#byte-order-size-and-alignment">7.1.2.1. Byte Order, Size, and Alignment</a></li>
<li class="toctree-l3"><a class="reference internal" href="struct.html#format-characters">7.1.2.2. Format Characters</a></li>
<li class="toctree-l3"><a class="reference internal" href="struct.html#examples">7.1.2.3. Examples</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="struct.html#classes">7.1.3. Classes</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="codecs.html">7.2. <code class="docutils literal"><span class="pre">codecs</span></code> &#8212; Codec registry and base classes</a><ul>
<li class="toctree-l2"><a class="reference internal" href="codecs.html#codec-base-classes">7.2.1. Codec Base Classes</a><ul>
<li class="toctree-l3"><a class="reference internal" href="codecs.html#error-handlers">7.2.1.1. Error Handlers</a></li>
<li class="toctree-l3"><a class="reference internal" href="codecs.html#stateless-encoding-and-decoding">7.2.1.2. Stateless Encoding and Decoding</a></li>
<li class="toctree-l3"><a class="reference internal" href="codecs.html#incremental-encoding-and-decoding">7.2.1.3. Incremental Encoding and Decoding</a><ul>
<li class="toctree-l4"><a class="reference internal" href="codecs.html#incrementalencoder-objects">7.2.1.3.1. IncrementalEncoder Objects</a></li>
<li class="toctree-l4"><a class="reference internal" href="codecs.html#incrementaldecoder-objects">7.2.1.3.2. IncrementalDecoder Objects</a></li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="codecs.html#stream-encoding-and-decoding">7.2.1.4. Stream Encoding and Decoding</a><ul>
<li class="toctree-l4"><a class="reference internal" href="codecs.html#streamwriter-objects">7.2.1.4.1. StreamWriter Objects</a></li>
<li class="toctree-l4"><a class="reference internal" href="codecs.html#streamreader-objects">7.2.1.4.2. StreamReader Objects</a></li>
<li class="toctree-l4"><a class="reference internal" href="codecs.html#streamreaderwriter-objects">7.2.1.4.3. StreamReaderWriter Objects</a></li>
<li class="toctree-l4"><a class="reference internal" href="codecs.html#streamrecoder-objects">7.2.1.4.4. StreamRecoder Objects</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="codecs.html#encodings-and-unicode">7.2.2. Encodings and Unicode</a></li>
<li class="toctree-l2"><a class="reference internal" href="codecs.html#standard-encodings">7.2.3. Standard Encodings</a></li>
<li class="toctree-l2"><a class="reference internal" href="codecs.html#python-specific-encodings">7.2.4. Python Specific Encodings</a><ul>
<li class="toctree-l3"><a class="reference internal" href="codecs.html#text-encodings">7.2.4.1. Text Encodings</a></li>
<li class="toctree-l3"><a class="reference internal" href="codecs.html#binary-transforms">7.2.4.2. Binary Transforms</a></li>
<li class="toctree-l3"><a class="reference internal" href="codecs.html#text-transforms">7.2.4.3. Text Transforms</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="codecs.html#module-encodings.idna">7.2.5. <code class="docutils literal"><span class="pre">encodings.idna</span></code> &#8212; Internationalized Domain Names in Applications</a></li>
<li class="toctree-l2"><a class="reference internal" href="codecs.html#module-encodings.mbcs">7.2.6. <code class="docutils literal"><span class="pre">encodings.mbcs</span></code> &#8212; Windows ANSI codepage</a></li>
<li class="toctree-l2"><a class="reference internal" href="codecs.html#module-encodings.utf_8_sig">7.2.7. <code class="docutils literal"><span class="pre">encodings.utf_8_sig</span></code> &#8212; UTF-8 codec with BOM signature</a></li>
</ul>
</li>
</ul>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h4>Previous topic</h4>
  <p class="topless"><a href="rlcompleter.html"
                        title="previous chapter">6.8. <code class="docutils literal"><span class="pre">rlcompleter</span></code> &#8212; Completion function for GNU readline</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="struct.html"
                        title="next chapter">7.1. <code class="docutils literal"><span class="pre">struct</span></code> &#8212; Interpret bytes as packed binary data</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/binary.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="struct.html" title="7.1. struct — Interpret bytes as packed binary data"
             >next</a> |</li>
        <li class="right" >
          <a href="rlcompleter.html" title="6.8. rlcompleter — Completion function for GNU readline"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>